<template>
    <ul id="dossard-list">
        <h2 v-if="dossardList.length === 0 && !isLoaded && !isError">Chargements des dossards...</h2>
        <li v-else-if="dossardList.length > 0" v-for="(dossard, index) in dossardList" :key="index">
            <Dossard :dossard-data="dossard"></Dossard>
        </li>
        <h2 v-else-if="!isError">Pas de dossards.</h2>
        <h2 v-else>Une erreur est survenue</h2>
    </ul>
</template>

<script>
    import config from "../../js/config.js";
    import Dossard from "./Dossard.vue";
    import axios from "axios";

    export default {
        name: "DossardList",
        components: {
            Dossard: Dossard,
        },
        data: function () {
            return {
                dossardList: [],
                isLoaded: false,
                isError: false,
                idEpreuve: ""
            };
        },
        created() {
            let params = this.$parent.$parent.params;
            this.idEpreuve = params.epreuve;
            this.initialise();
        },
        methods: {
            initialise() {
                if (localStorage.id_roleUser === "1") {
                    this.requete = "https://" + config.host + "/dossardsbyepreuve/" + this.idEpreuve
                } else {
                    this.requete = "https://" + config.host + "/dossardsbyepreuvebyuser/" + localStorage.idUser + "/" + this.idEpreuve
                }
                axios
                    .get(this.requete)
                    .then(response => {
                        // handle success
                        console.log(response);
                        this.dossardList = response.data;
                        this.isLoaded = true;
                    })
                    .catch(error => {
                        // handle error
                        this.isError = true;
                        console.log(error);
                    });
            }
        }
    };
</script>

<style>
    li {
        list-style-type: none;
        background-color: lightblue;
        margin: 2% 0 5% 0;
    }

    ul {
        overflow-y: scroll;
        height: 98%;
        padding-inline-start: 5px;
        margin-block-start: 0.2em;
        margin-block-end: 0.2em;
    }
</style>